// $Id$
#ifndef __INLINE_H__
#define __INLINE_H__

#ifdef GIDS

#ifndef IPFW
#ifdef NFNETLINKQ
//#include <linux/netfilter/nfnetlink_queue.h>
#include <libnetfilter_queue/libnetfilter_queue.h>
#include <libnetfilter_queue/libipq.h>
#include <net/if.h>
#else
#include <libipq.h>
#endif /* NFNETLINKQ */
#include <linux/netfilter.h>
#else /* IPFW */
#include <sys/types.h>
#include <sys/time.h>
#include <sys/unistd.h>
#include <errno.h>
#endif /* IPFW */

#include "snort.h"
int InlineMode();
int InlineModeSetPrivsAllowed();
int InlineDrop(Packet *p);  /* call to drop current packet */
int InlineDropPacketOnly(Packet *p);  /* call to drop current packet */
int InlineWasPacketDropped();
int opdsize;  /* original packet p->dsize for resets */

typedef struct _inline_vals
{
    int drop;
    int rejectsrc;
    int rejectdst;
    int reinject;
    int replace;
    int proto;
} IV;

#ifdef CP_CHANGES
#ifdef STM
struct pseudoheader       /* pseudo header for TCP checksum calculations */
{
        u_int32_t sip, dip;   /* IP addr */
        u_int8_t  zero;       /* checksum placeholder */
        u_int8_t  protocol;   /* protocol number */
        u_int16_t tcplen;     /* tcp packet length */
};
#endif /* STM */
#ifdef UTM
#define NFQUEUE_BLOCK_TIME_SEC    0        /* Block timeout(sec) for NFQUEUE socket */
#define NFQUEUE_BLOCK_TIME_USEC   100000   /* Block timeout(usec) for NFQUEUE socket */ 
/*
 * The values of packet direction.
 *
 * DIRECTION_UNKNOWN means we can't determine packet direction from mark.
 * 
 * TO_WAN means the packet is sent to WAN interface.
 * 
 * FROM_WAN means the packet is received from WAN interface.
 * 
 * SSL_TUNNEL_VPN_PACKET means this packet belongs to SSL VPN tunnel conntrack.
 * If we find a SSL VPN tunnel packet, we will or the direction value with
 * SSL_TUNNEL_VPN_PACKE. So the value of direction can be DIRECTION_UNKNOWN|SSL_TUNNEL_VPN_PACKET,
 * TO_WAN|SSL_TUNNEL_VPN_PACKET, FROM_WAN|SSL_TUNNEL_VPN_PACKET
 *
 */
#define DIRECTION_UNKNOWN 0
#define TO_WAN   1
#define FROM_WAN   2
#define SSL_VPN_PACKET 4
#define BETWEEN_SSL_AND_LAN 8
#endif /* UTM */
#endif /* CP_CHANGES */


#ifdef NFNETLINKQ
u_int16_t nfqueue_num;
struct nfnl_handle *nh;
#else
#ifndef IPFW
struct ipq_handle *ipqh;
#else
int divert_socket;
#endif /* IPFW */
#endif /* NFNETLINKQ */

IV iv;

int InitInline();
void InitInlinePostConfig(void);
void RejectFuRestart();
int InlineReject(Packet *); /* call to reject src in current packet for compat */
int InlineRejectBoth(Packet *); /* call to reject current packet in both directions */
int InlineRejectSrc(Packet *); /* call to reject src in current packet */
int InlineRejectDst(Packet *); /* call to reject dst in current packet */
#ifdef IPFW
int InlineReinject(Packet *); /* call to reinject current packet */
#endif /* IPFW */
int InlineAccept();
int InlineReplace();

#ifdef NFNETLINKQ
void NfnetlinkQLoop();
#else

#ifndef IPFW
void IpqLoop();
#else
void IpfwLoop();
#endif /* IPFW */
#endif /* NFNETLINKQ */
#endif /* GIDS */

#endif /* __INLINE_H__ */
